'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Popup = exports.POPUP_THEME_SHAPE_OBJECT = exports.POPUP = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _pure = require('../../utils/pure');

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Portal = require('react-overlays/lib/Portal');

var _Portal2 = _interopRequireDefault(_Portal);

var _propTypes = require('prop-types');

var PropTypes = _interopRequireWildcard(_propTypes);

var _withTheme = require('../../utils/withTheme');

var _RootClose = require('../RootClose/RootClose');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var POPUP = exports.POPUP = Symbol('Popup');
var POPUP_THEME_SHAPE_OBJECT = exports.POPUP_THEME_SHAPE_OBJECT = {
    container: PropTypes.string,
    header: PropTypes.string,
    body: PropTypes.string,
    footer: PropTypes.string
};
var RawPopup = function (_Component) {
    _inherits(RawPopup, _Component);

    function RawPopup() {
        _classCallCheck(this, RawPopup);

        var _this = _possibleConstructorReturn(this, (RawPopup.__proto__ || Object.getPrototypeOf(RawPopup)).apply(this, arguments));

        _this.handleBackdropClick = function (e) {
            var _this$props = _this.props,
                shouldCloseOnClickAway = _this$props.shouldCloseOnClickAway,
                onRequestClose = _this$props.onRequestClose;

            if (shouldCloseOnClickAway && onRequestClose) {
                var isModal = _this.props.isModal;

                if (isModal) {
                    //popup is modal - backdrop handles clicks
                    //don't process click inside popup container (bubbled events)
                    if (e.target === _this.backdrop) {
                        onRequestClose();
                    }
                }
                //if popup isn't modal then it's closed by RootClose
            }
        };
        return _this;
    }

    _createClass(RawPopup, [{
        key: 'render',
        value: function render() {
            var _classnames,
                _this2 = this;

            var _props = this.props,
                theme = _props.theme,
                header = _props.header,
                children = _props.children,
                footer = _props.footer,
                isModal = _props.isModal,
                container = _props.container,
                isOpened = _props.isOpened,
                shouldCloseOnClickAway = _props.shouldCloseOnClickAway,
                onRequestClose = _props.onRequestClose;

            if (!isOpened) {
                return null;
            }
            var backdropClassName = (0, _classnames3.default)(theme.backdrop, (_classnames = {}, _defineProperty(_classnames, theme.backdrop_isModal, isModal), _defineProperty(_classnames, theme.backdrop_closeOnClickAway, shouldCloseOnClickAway), _classnames));
            var child = React.createElement(_RootClose.RootClose, { onRootClose: onRequestClose, ignoreKeyUp: !shouldCloseOnClickAway, ignoreClick: !shouldCloseOnClickAway || isModal }, React.createElement("div", { className: backdropClassName, ref: function ref(el) {
                    return _this2.backdrop = el;
                }, onClick: this.handleBackdropClick }, React.createElement("div", { className: theme.container }, header && React.createElement("div", { className: theme.header }, header), React.createElement("div", { className: theme.body }, children), footer && React.createElement("div", { className: theme.footer }, footer))));
            // //if popup is modal then it should be closed only on click on backdrop
            // //if popup isn't modal then backdrop has pointer-events: none and click should be detected by RootClose
            // if (shouldCloseOnClickAway) {
            // 	child = (
            // 		<RootClose ignoreClick={isModal}>
            // 			{child}
            // 		</RootClose>
            // 	);
            // }
            child = React.createElement(_Portal2.default, { container: container }, child);
            return child;
        }
    }]);

    return RawPopup;
}(_react.Component);
RawPopup = tslib_1.__decorate([_pure.PURE], RawPopup);
var Popup = exports.Popup = (0, _withTheme.withTheme)(POPUP)(RawPopup);