'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Popup = require('./Popup');

var _storybook = require('@devexperts/tools/lib/utils/storybook');

var _pure = require('../../utils/pure');

var _Demo = require('../demo/Demo');

var _Demo2 = _interopRequireDefault(_Demo);

var _Button = require('../Button/Button');

var _Selectbox = require('../Selectbox/Selectbox');

var _Control = require('../Control/Control');

var _Menu = require('../Menu/Menu');

var _PopupPage = require('./Popup.page.styl');

var _PopupPage2 = _interopRequireDefault(_PopupPage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var theme = {
    container: _PopupPage2.default.container
};
var popupTheme = {
    container: _PopupPage2.default.popup
};
var header = _react2.default.createElement("div", null, "HEADER");
var footer = _react2.default.createElement("div", null, "FOOTER");
var Stateful = (0, _Control.stateful)()(_Selectbox.Selectbox);
var container = document.getElementById('root');
var PopupPage = function (_React$Component) {
    _inherits(PopupPage, _React$Component);

    function PopupPage() {
        _classCallCheck(this, PopupPage);

        var _this = _possibleConstructorReturn(this, (PopupPage.__proto__ || Object.getPrototypeOf(PopupPage)).apply(this, arguments));

        _this.state = {
            isOpened: false,
            isModal: false,
            shouldCloseOnClickAway: false
        };
        _this.onToggleClick = function (e) {
            _this.setState({
                isOpened: !_this.state.isOpened
            });
        };
        _this.onIsModalChange = function (e) {
            _this.setState({
                isModal: !_this.state.isModal
            });
        };
        _this.onCloseOnClickAwayChange = function (e) {
            _this.setState({
                shouldCloseOnClickAway: !_this.state.shouldCloseOnClickAway
            });
        };
        _this.onPopupRequestClose = function () {
            _this.setState({
                isOpened: false
            });
        };
        return _this;
    }

    _createClass(PopupPage, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var html = document.querySelector('html');
            if (html) {
                html.classList.add(_PopupPage2.default.html);
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var html = document.querySelector('html');
            if (html) {
                html.classList.remove(_PopupPage2.default.html);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _state = this.state,
                isOpened = _state.isOpened,
                isModal = _state.isModal,
                shouldCloseOnClickAway = _state.shouldCloseOnClickAway;

            return _react2.default.createElement(_Demo2.default, { theme: theme }, _react2.default.createElement("label", { className: _PopupPage2.default.label }, "Modal ", _react2.default.createElement("input", { type: "checkbox", value: isModal.toString(), onChange: this.onIsModalChange })), _react2.default.createElement("label", { className: _PopupPage2.default.label }, "Close on clickaway ", _react2.default.createElement("input", { type: "checkbox", value: shouldCloseOnClickAway.toString(), onChange: this.onCloseOnClickAwayChange })), !isModal && shouldCloseOnClickAway && _react2.default.createElement("label", { className: _PopupPage2.default.label }, "When isModal === false && shouldCloseOnClickAway === true popup will close on click inside inner selectbox, because there is no backdrop and selectbox is rendered to body"), _react2.default.createElement(_Button.Button, { isPrimary: true, onClick: this.onToggleClick }, isOpened ? 'Close' : 'Open', _react2.default.createElement(_Popup.Popup, { theme: popupTheme, header: header, footer: footer, isModal: isModal, shouldCloseOnClickAway: shouldCloseOnClickAway, onRequestClose: this.onPopupRequestClose, isOpened: isOpened, container: container }, _react2.default.createElement("div", null, "popup content"), _react2.default.createElement(Stateful, { placeholder: "Choose your hero" }, _react2.default.createElement(_Menu.MenuItem, { value: "superman" }, "Superman"), _react2.default.createElement(_Menu.MenuItem, { value: "batman" }, "Batman"), _react2.default.createElement(_Menu.MenuItem, { value: "flash" }, "Flash")))));
        }
    }]);

    return PopupPage;
}(_react2.default.Component);
PopupPage = tslib_1.__decorate([_pure.PURE], PopupPage);
(0, _storybook.storiesOf)('Popup', module).add('Default', function () {
    return _react2.default.createElement(PopupPage, null);
});