'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Scrollable = exports.RawScrollable = exports.SCROLLABLE = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Scrollable = require('./Scrollable.const');

var _Scrollbar = require('../Scrollbar/Scrollbar');

var _ResizeDetector = require('../ResizeDetector/ResizeDetector');

var _HorizontalScrollbar = require('../Scrollbar/HorizontalScrollbar');

var _VerticalScrollbar = require('../Scrollbar/VerticalScrollbar');

var _Scrollbar2 = require('../Scrollbar/Scrollbar.util');

var _Scrollbar3 = _interopRequireDefault(_Scrollbar2);

var _withTheme = require('../../utils/withTheme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCROLLABLE = exports.SCROLLABLE = Symbol('Scrollable');

var RawScrollable = exports.RawScrollable = function (_React$Component) {
    _inherits(RawScrollable, _React$Component);

    function RawScrollable() {
        _classCallCheck(this, RawScrollable);

        var _this = _possibleConstructorReturn(this, (RawScrollable.__proto__ || Object.getPrototypeOf(RawScrollable)).apply(this, arguments));

        _this._withHorizontalScrollbar = false;
        _this._withVerticalScrollbar = false;
        _this.state = {
            container: void 0,
            scrollable: void 0
        };
        _this.onScroll = function (event) {
            var _event$target = event.target,
                scrollLeft = _event$target.scrollLeft,
                scrollTop = _event$target.scrollTop;
            var onScroll = _this.props.onScroll;

            onScroll && onScroll(scrollLeft, scrollTop);
        };
        _this.onScrollbarUpdate = function (type, isVisible) {
            var onUpdate = _this.props.onUpdate;

            switch (type) {
                case _Scrollbar.SCROLLBAR_TYPE.VERTICAL:
                    {
                        _this._withVerticalScrollbar = isVisible;
                        break;
                    }
                case _Scrollbar.SCROLLBAR_TYPE.HORIZONTAL:
                    {
                        _this._withHorizontalScrollbar = isVisible;
                        break;
                    }
            }
            _this.forceUpdate();
            onUpdate && onUpdate(_this._withHorizontalScrollbar, _this._withVerticalScrollbar);
        };
        _this.onResize = function () {
            _this._emitter.emit(_Scrollable.EVENT_SCROLABLE.RESIZE);
        };
        return _this;
    }

    _createClass(RawScrollable, [{
        key: 'getChildContext',
        value: function getChildContext() {
            var theme = this.props.theme;

            return _defineProperty({
                size: (0, _Scrollbar3.default)(theme.container)
            }, _Scrollable.SCROLLABLE_CONTEXT_EMITTER.toString(), this._emitter);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.setState({
                container: this._container
            });
            this._emitter.on(_Scrollable.EVENT_SCROLABLE.SCROLLBAR_UPDATE, this.onScrollbarUpdate);
            this._emitter.on(_Scrollable.EVENT_SCROLABLE.SCROLL, this.onScroll);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this._emitter.off(_Scrollable.EVENT_SCROLABLE.SCROLLBAR_UPDATE, this.onScrollbarUpdate);
            this._emitter.off(_Scrollable.EVENT_SCROLABLE.SCROLL, this.onScroll);
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
            this._emitter = new _Scrollable.ScrollableInternalEmitter();
        }
    }, {
        key: 'render',
        value: function render() {
            var _classnames,
                _this2 = this;

            var _props = this.props,
                theme = _props.theme,
                ResizeDetector = _props.ResizeDetector,
                VerticalScrollbar = _props.VerticalScrollbar,
                HorizontalScrollbar = _props.HorizontalScrollbar;

            var children = React.Children.only(this.props.children);
            var container = this.state.container;

            var className = (0, _classnames3.default)(theme.scrollable, (_classnames = {}, _defineProperty(_classnames, theme.withHorizontalScrollbar, this._withHorizontalScrollbar), _defineProperty(_classnames, theme.withVerticalScrollbar, this._withVerticalScrollbar), _classnames), children.props.className || '');
            var containerClassName = (0, _classnames3.default)(theme.scrollbar, {
                withBothScrollabars: this._withHorizontalScrollbar && this._withVerticalScrollbar
            });
            var resizeDetectorProps = {
                theme: {
                    container: theme.resizeDetector
                },
                onResize: this.onResize
            };
            return React.createElement("div", { className: className, ref: function ref(el) {
                    return _this2._scrollable = el;
                } }, React.createElement("div", { className: theme.wrapper }, React.createElement("div", { className: theme.container, ref: function ref(el) {
                    return _this2._container = el;
                } }, React.createElement("div", { className: theme.content }, React.cloneElement(children, {
                className: null
            }), React.createElement(ResizeDetector, Object.assign({}, resizeDetectorProps)))), container && [React.createElement(HorizontalScrollbar, { ref: function ref(el) {
                    return _this2._horizontalScrollbar = el;
                }, key: "horizontalScrollbar", container: container, scrollLeft: this.props.scrollLeft, theme: {
                    bar: theme.horizontal_scrollbar__bar,
                    container: containerClassName
                } }), React.createElement(VerticalScrollbar, { ref: function ref(el) {
                    return _this2._verticalScrollbar = el;
                }, key: "verticalScrollbar", container: container, scrollTop: this.props.scrollTop, theme: {
                    bar: theme.vertical_scrollbar__bar,
                    container: containerClassName
                } })]), React.createElement(ResizeDetector, Object.assign({}, resizeDetectorProps)));
        }
    }]);

    return RawScrollable;
}(React.Component);

RawScrollable.defaultProps = {
    ResizeDetector: _ResizeDetector.ResizeDetector,
    VerticalScrollbar: _VerticalScrollbar.VerticalScrollbar,
    HorizontalScrollbar: _HorizontalScrollbar.HorizontalScrollbar
};
RawScrollable.childContextTypes = _Scrollable.CONTEXT_TYPES;
var Scrollable = exports.Scrollable = (0, _withTheme.withTheme)(SCROLLABLE)(RawScrollable);